program Transientenrekorder;
uses Crt, RS232, Graph;
var   Wert                   :   Byte;
      Ch                     :   Char;
      Abtastrate             :   Real;
      i, j                   :   Integer;
      GraphMode, GraphDriver :   Integer;
      Puffer                 :   ARRAY [1..512] OF BYTE;


procedure Oeffnen19200;
   var  Wert : Byte;
   begin
     Port [$3FB]:=128;          { Baudeingabe aktivieren     }
     Port [$3F8]:=  6;          { Baudrate - LSB, 19200 Baud }
     Port [$3F9]:=  0;          { Baudrate - MSB             }
     Port [$3FB]:=  3;          { 8 Bits, No Parity, 1 Stop  }
     Port [$3FC]:=  3;          { DTR = 1, CTS = 1           }
     Wert := Port [$3F8]        { Empfangsregister leeren    }
   end;


procedure RAMplot;
begin
   BusIn (65,Wert);
   Puffer[1] := Wert div 2;
   for i := 2 to 512 do
   begin
      BusIn (65,Wert);
      Puffer[i] := Wert div 2;
      Line (50+i, 168-Puffer[i],50+i-1,168-Puffer[i-1]);
   end;
end;


procedure Diagramm;
begin
   Line (50,40,562,40);         Line (562,40,562,168);
   Line (562,168,50,168);       Line (50,168,50,40);
   for j := 0 to 16 do
   begin
     for i := 0 to 16 do
     begin
       PutPixel (50+i*32,40+j*8,1);
     end;
   end;
end;

.pa
procedure Vortrigger (Abtastrate : Real);
var Teiler     :   Integer;
    High, Low  :   Byte;
begin
  Teiler := trunc  (1000 / Abtastrate);
  High := Hi (Teiler);   Low  := Lo (Teiler);
  BusOut (67,130);       BusOut (71, 52);
  BusOut (68,  4);       BusOut (68,  0);
  BusOut (71,116);       BusOut (69, Low );
  BusOut (69, High);     BusOut (76,  0);
  BusOut (71,176);       BusOut (70,  0);
  BusOut (70, 64);       BusOut (66, 72 );
  repeat
    Ch := ' ';
    Ch := ReadKey;
  until Ch = '1';
  BusOut (72,  0);
  delay (Teiler * 16);
  BusOut (66, 40);
end;


begin
  Oeffnen19200;
  ClrScr;
  Writeln ('Abtastrate in kHz' );
  Readln (Abtastrate);
  GraphDriver := Detect;
  InitGraph (GraphDriver, GraphMode, '');
  ClearDevice;
  OutTextXY (50,0,'Start <1>   Plot <2>  Abtastrate  <a>   Ende <e>');
    repeat
      Ch := ' ';
      Ch := ReadKey;
        if Ch = 'a' then read (Abtastrate);
        if Ch = '2' then begin
           ClearDevice; Diagramm; RAMplot;
           end;
        if Ch = '1' then begin
           Vortrigger (Abtastrate); ClearDevice; Diagramm; RAMplot;
           end;
      OutTextXY (50,0,'Start <1>   Plot <2>  Abtastrate  <a>   Ende <e>');
    until (Ch = 'e')
end.
